include file.e
include get.e
include graphics.e

without warning
without type_check

constant ACT_ANALYZE = '1',
	 ACT_SET_AVG = '2',
	 ACT_ADJ_FIX = '3',
	 ACT_FADE_IN = '4',
	 ACT_FADE_OUT = '5',
	 ACT_RESAMPLE = '6',
	 ACT_SET_RES = '7',
	 ACT_SET_CHN = '8',
	 ACT_QUIT = '9'

constant freq = {
8000,
11025,
16000,
22050,
32000,
44100,
48000}


sequence infile,outfile


sequence s,t,u,v
integer fn,outf,f,g,h,i,j,data_size,data_start,
	action,des_avg_vol
integer resample,channels,reduction,resolution
atom vol_mult,fade_time,fade_step
atom sample_pos,sample_step

integer
	wav_format,
	wav_channels,
	wav_samplespersec,
	wav_avgbytespersec,
	wav_blockalign,
	wav_bitspersample
	

procedure ERROR(sequence e)
	puts(1,e)
	close(fn)
	abort(0)
end procedure


function get_word(integer fh)
	integer dw
	
	dw = getc(fh)
	dw += (getc(fh)*#100)
	return dw
end function


-- Get a signed word from file fh
function get_sword(integer fh)
	integer dw
	
	dw = getc(fh)
	if dw=-1 then
		return 65536
	end if
	dw += (getc(fh)*#100)
	if and_bits(dw,#8000) then
		return -(32768-and_bits(dw,#7FFF))
	end if
	return dw
end function


-- Get a dword from file fh
function get_dword(integer fh)
	integer dw
	
	dw = getc(fh)
	dw += (getc(fh)*#100)
	dw += (getc(fh)*#10000)
	dw += (getc(fh)*#1000000)
	return dw
end function


procedure put_word(integer fh,integer w)
	puts(fh,{w,floor(w/#100)})
end procedure


procedure put_sword(integer fh,integer w)
	if w<0 then
		w = or_bits(32768+w,#8000)
	end if
	puts(fh,{w,floor(w/#100)})
end procedure


procedure put_dword(integer fh,integer dw)
	puts(fh,{dw,floor(dw/#100),floor(dw/#10000),floor(dw/#1000000)})
end procedure


function abs(integer x)
	if x<0 then
		return -x
	end if
	return x
end function


procedure write_wav_hdr(integer fh)
	puts(fh,"RIFF")
	put_dword(fh,12+16+8+floor((data_size/wav_avgbytespersec)*resample*channels*floor(resolution/8)))
	puts(fh,"WAVE")
	puts(fh,"fmt "&{16,0,0,0})
	puts(fh,{1,0,channels,0})
	put_dword(fh,resample)
	put_dword(fh,resample*channels*floor(resolution/8))
	put_word(fh,wav_blockalign)
	put_word(fh,resolution)
	puts(fh,"data")
	put_dword(fh,floor((data_size/wav_avgbytespersec)*resample*channels*floor(resolution/8)))	
end procedure


function PBar(integer max)
	sequence pos

	pos = get_position()
	puts(1,"[                    ]")
	return {pos,0,max}
end function


procedure update_PBar(sequence pb,integer x)
	sequence pos
	integer y
	
	y = floor(20*x/pb[3])
	if y<1 then return end if
	pos = get_position()
	position(pb[1][1],pb[1][2]+y)
	puts(1,".")
	position(pos[1],pos[2])
end procedure



channels = 0
resample = 0
resolution = 0
reduction = 0

puts(1,"WAVEdit \n/Mic, 2002\n\n")
puts(1,"Input file: ")
infile = gets(0)
infile = infile[1..length(infile)-1]
puts(1,"\n")

puts(1,"\n[1] Analyze file")
puts(1,"\n[2] Set an absolute avg. volume")
puts(1,"\n[3] Adjust the volume by a given percentage")
puts(1,"\n[4] Apply fade-in")
puts(1,"\n[5] Apply fade-out")
puts(1,"\n[6] Resample")
puts(1,"\n[7] Set resolution")
puts(1,"\n[8] Set number of channels")
puts(1,"\n[9] Quit\n")

i = 0
while not (i>='1' and i<='9') do
	i = get_key()
end while
action = i

if i=ACT_ANALYZE then

elsif i='2' then
	puts(1,"\nDesired avg. volume: ")
	t = gets(0)
	t = t[1..length(t)-1]
	t = value(t)
	des_avg_vol = floor(t[2])
	if des_avg_vol<0 then
		des_avg_vol = 0
	end if
	
elsif i='3' then
	puts(1,"\nPercentage of original volume: ")
	t = gets(0)
	t = t[1..length(t)-1]
	t = value(t)
	j = t[2]
	if j<0 then
		j=0
	end if
	vol_mult = j/100

elsif i=ACT_FADE_IN or i=ACT_FADE_OUT then
	puts(1,"\nFading time: ")
	t = gets(0)
	t = t[1..length(t)-1]
	t = value(t)
	fade_time = t[2]
	if fade_time<0 then abort(0) end if

elsif i=ACT_RESAMPLE then
	puts(1,"\n[1] 8000  Hz")
	puts(1,"\n[2] 11025 Hz")
	puts(1,"\n[3] 16000 Hz")
	puts(1,"\n[4] 22050 Hz")
	puts(1,"\n[5] 32000 Hz")
	puts(1,"\n[6] 44100 Hz")
	puts(1,"\n[7] 48000 Hz\n")
	i = 0
	while not (i>='1' and i<='7') do
		i = get_key()
	end while
	resample = freq[i-'0']
	
elsif i=ACT_SET_RES then
	puts(1,"\n[1] 8  bits/sample")
	puts(1,"\n[2] 16 bits/sample\n")
	i = 0
	while not (i>='1' and i<='2') do
		i = get_key()
	end while
	resolution = 8*(i-'0')

elsif i=ACT_SET_CHN then
	puts(1,"\n[1] 1 (mono)")
	puts(1,"\n[2] 2 (stereo)\n")
	i = 0
	while not (i>='1' and i<='2') do
		i = get_key()
	end while
	channels = i-'0'
	
	if channels=1 then
		puts(1,"\n[1] Mix channels")
		puts(1,"\n[2] Keep left channel")
		puts(1,"\n[3] Keep right channel\n")
		i = 0
		while not (i>='1' and i<='3') do
			i = get_key()
		end while
		reduction = i-'0'
	end if

else
	abort(0)
end if


if action!=ACT_ANALYZE then
	puts(1,"\n\nWrite output to: ")
	outfile = gets(0)
	outfile = outfile[1..length(outfile)-1]
	puts(1,"\n")
end if


fn = open(infile,"rb")
if fn<0 then
	puts(1,"Unable to open " & infile)
	abort(0)
end if

s = get_bytes(fn,4)
if not equal(s,"RIFF") then
	ERROR("No RIFF tag found")
end if
i = get_dword(fn)
s = get_bytes(fn,4)
if not equal(s,"WAVE") then
	ERROR("No WAVE tag found")
end if


    
atom avg_vol

data_size = -1

clear_screen()

-- Read the chunks
while 1 do
	-- Get the chunk ID
	s = get_bytes(fn,4)
	if length(s)<4 then
		exit
	end if

	-- Get the chunk size
	i = get_dword(fn)
	
	if equal(s,"fmt ") then
		wav_format = get_word(fn)
		wav_channels = get_word(fn)
		wav_samplespersec = get_dword(fn)
		wav_avgbytespersec = get_dword(fn)
		wav_blockalign = get_word(fn)
		wav_bitspersample = get_word(fn)
		
		if channels=0 then
			channels = wav_channels
		end if
		if resample=0 then
			resample = wav_samplespersec
		end if
		if resolution=0 then
			resolution = wav_bitspersample
		end if
		
		printf(1,"Original format:\nType:        %d\nChannels:    %d\nSamples/sec: %d\nBits/sample: %d\n",
			{wav_format,wav_channels,wav_samplespersec,wav_bitspersample})
		
		if wav_format!=1 or (wav_bitspersample!=8 and wav_bitspersample!=16) then
			ERROR("Bad format")
		end if
		
	elsif equal(s,"data") then
		avg_vol = 0
		data_start = where(fn)
		data_size = i

		if action = ACT_ANALYZE then
			puts(1,"\nAnalyzing wave data:\n")
			u = PBar(data_size)
			
			if wav_bitspersample=8 then
				g = floor(data_size/20)
				h = g
				for k=1 to data_size do
					avg_vol += getc(fn)
					h -= 1
					if h=0 then
						update_PBar(u,k*2)
						h = g
					end if
				end for
			else
				g = floor(data_size/40)
				h = g
				for k=1 to floor(data_size/2) do
					j = get_sword(fn)
					avg_vol += abs(j)
					h -= 1
					if h=0 then
						update_PBar(u,k*2)
						h = g
					end if
				end for
			end if
			update_PBar(u,data_size)
			avg_vol /= data_size
			avg_vol *= 2.0
			printf(1,"\n\nLength: %1.2f s\nCurrent avg. volume: %d\n",{data_size/wav_avgbytespersec,floor(avg_vol)})
		
		elsif action = ACT_SET_AVG then
			puts(1,"\nAdjusting volume:\n")
			u = PBar(floor(data_size/2))

			for k=1 to floor(data_size/2) do
				j = get_sword(fn)
				avg_vol += abs(j)
			end for
			avg_vol /= data_size
			avg_vol *= 2.0
			vol_mult = des_avg_vol / avg_vol
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)

			g = floor(data_size/40)
			h = g
			
			if seek(fn,data_start) then end if
			for k=1 to floor(data_size/2) do
				j = floor(get_sword(fn)*vol_mult)
				if j>32767 then
					j = 32767
				elsif j<-32768 then
					j = -32768
				end if
				put_sword(outf,j)
				h -= 1
				if h=0 then
					update_PBar(u,k)
					h = g
				end if
			end for
			close(outf)

		elsif action = ACT_ADJ_FIX then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)
			puts(1,"\nAdjusting volume:\n")
			u = PBar(floor(data_size/2))
		
			g = floor(data_size/40)
			h = g
			for k=1 to floor(data_size/2) do
				j = floor(get_sword(fn)*vol_mult)
				if j>32767 then
					j = 32767
				elsif j<-32768 then
					j = -32768
				end if
				put_sword(outf,j)
				h -= 1
				if h=0 then
					update_PBar(u,k)
					h = g
				end if
			end for
			update_PBar(u,floor(data_size/2))
			close(outf)
		
		elsif action = ACT_FADE_IN then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)
			i = floor(fade_time*wav_samplespersec)
			vol_mult = 0
			fade_step = 1.0/i
			for k=1 to i do
				for l=1 to wav_channels do
					if wav_bitspersample=8 then
						puts(outf,floor(getc(fn)*vol_mult))
					else
						j = floor(get_sword(fn)*vol_mult)
						put_sword(outf,j)
					end if
				end for
				vol_mult += fade_step
			end for
			for k=(i*wav_channels*floor(wav_bitspersample/8)) to data_size-1 do
				puts(outf,getc(fn))
			end for
			close(outf)
			
		elsif action = ACT_FADE_OUT then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)
			i = floor(fade_time*wav_samplespersec)
			vol_mult = 1.0
			fade_step = -1.0/i

			for k=1 to data_size-(i*wav_channels*floor(wav_bitspersample/8)) do
				puts(outf,getc(fn))
			end for
			
			for k=1 to i do
				for l=1 to wav_channels do
					if wav_bitspersample=8 then
						puts(outf,floor(getc(fn)*vol_mult))
					else
						j = floor(get_sword(fn)*vol_mult)
						put_sword(outf,j)
					end if
				end for
				vol_mult += fade_step
			end for
			close(outf)
		
		elsif action = ACT_RESAMPLE then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)

			if resample = wav_samplespersec then
				for k=1 to data_size do
					puts(outf,getc(fn))
				end for
			else
				sample_pos = 0
				sample_step = (wav_samplespersec/resample)
				f = floor((data_size/wav_avgbytespersec)*resample)
				i = channels*floor(resolution/8)
	
				puts(1,"\nResampling:\n")
				u = PBar(f)
				g = floor(f/20)
				h = g
			
				for k=0 to f do
					if seek(fn,data_start+(floor(sample_pos)*i)) then end if
					for l=1 to channels do
						puts(outf,getc(fn))
						if wav_bitspersample>8 then
							puts(outf,getc(fn))
						end if
					end for
					sample_pos += sample_step
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,f)
			end if
			close(outf)
			if seek(fn,data_size+data_start) then end if
			
		elsif action = ACT_SET_RES then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)
			puts(1,"\nChanging resolution:\n")
			
			if resolution = wav_bitspersample then
				u = PBar(data_size)
				g = floor(data_size/20)
				h = g	
				for k=1 to data_size do
					puts(outf,getc(fn))
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,data_size)
			elsif resolution < wav_bitspersample then
				-- Assume we want to convert from 16 bits to 8 bits
				f = floor(data_size*8/wav_bitspersample)
				u = PBar(f)
				g = floor(f/20)
				h = g	
				for k=1 to f do
					-- Convert signed 16 bits to unsigned 8 bits
					puts(outf,floor((get_sword(fn)+32768)/256))
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,f)
			else
				-- Assume we want to convert from 8 bits to 16 bits
				f = floor(data_size*8/wav_bitspersample)
				u = PBar(f)
				g = floor(f/20)
				h = g	
				for k=1 to f do
					-- Convert unsigned 8 bits to signed 16 bits
					j = getc(fn)-128
					put_sword(outf,j*256)
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,f)
			end if
			close(outf)
			
		elsif action = ACT_SET_CHN then
			outf = open(outfile,"wb")
			if outf<0 then
				puts(1,"Unable to open " & outfile)
				abort(0)
			end if
			write_wav_hdr(outf)
			
			if channels = wav_channels then
				puts(1,"\nWorking:\n")
				u = PBar(data_size)
				g = floor(data_size/20)
				h = g	
				for k=1 to data_size do
					puts(outf,getc(fn))
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,data_size)
			elsif channels < wav_channels then
				puts(1,"\nConverting to mono:\n")
				f = floor(data_size/(wav_channels*wav_bitspersample/8))
				u = PBar(f)
				g = floor(f/20)
				h = g	

				for k=1 to f do
					if wav_bitspersample=8 then
						if reduction=1 then
							j = getc(fn)
							j += getc(fn)
							puts(outf,floor(j/2))
						elsif reduction=2 then
							puts(outf,getc(fn))
							j = getc(fn)
						else
							j = getc(fn)
							puts(outf,getc(fn))
						end if
					else
						if reduction=1 then
							j = get_sword(fn)
							j += get_sword(fn)
							put_sword(outf,floor(j/2))
						elsif reduction=2 then
							puts(outf,getc(fn))
							puts(outf,getc(fn))
							j = get_word(fn)
						else
							j = get_word(fn)
							puts(outf,getc(fn))
							puts(outf,getc(fn))
						end if
						
					end if
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,f)
			else
				puts(1,"\nConverting to stereo:\n")
				f = floor(data_size/(wav_channels*wav_bitspersample/8))
				u = PBar(f)
				g = floor(f/20)
				h = g	
				
				for k=1 to f do
					if wav_bitspersample=8 then
						j = getc(fn)
						puts(outf,{j,j})
					else
						j = get_sword(fn)
						put_sword(outf,j)
						put_sword(outf,j)
					end if
					h -= 1
					if h=0 then
						update_PBar(u,k)
						h = g
					end if
				end for
				update_PBar(u,f)
			end if
			close(outf)
		end if
	else
		-- If we still haven't read the data chunk then we need read this one, but
		-- ignore the result.
		if data_size = -1 then
			for k=1 to i do
				j = getc(fn)
			end for
		else
			-- Don't read any other chunks if we already have the data chunk
			exit
		end if
	end if
end while


close(fn)

puts(1,"\n\nDone, press any key..")
while get_key()=-1 do end while

	